toTHMM <- function(coxdata) {
	UseMethod("toTHMM")
}

toTHMM.default <- function(coxdata) {
	stop("The requested conversion isn't implemented!", call.=FALSE)
}

toTHMM.CMM <- function(coxdata) {
	if ( !inherits(coxdata, "CMM") ) stop("'coxdata' must be of class 'CMM'", call.=FALSE)
	dados <- cbind(coxdata$id, coxdata$start, coxdata$stop, coxdata$event, coxdata$covariate, coxdata$trans)
	dados <- data.frame(dados, row.names=NULL)
	names(dados) <- c("id", "start", "stop", "event", "covariate", "trans")
	data <- dados
	data2 <- matrix(ncol=4, nrow=1)
	i <- 1
	while ( i <= (nrow(data)-1) ) {
		if (data[i,1] == data[i+1,1] & data[i,4] == 0 & data[i+1,4] == 0) {
			aux1 <- c(data[i,1], 0, 1, data[i,5])
			aux2 <- c(data[i,1], data[i,3], 1, data[i,5])
			data2 <- rbind(data2, aux1, aux2)
			i <- i+2
		}
		if (i <= (nrow(data)-1) & data[i,6] == 1 & data[i,4] == 1) {
			aux1 <- c(data[i,1], 0, 1, data[i,5])
			aux2 <- c(data[i,1], data[i,3], 3, data[i,5])
			data2 <- rbind(data2, aux1, aux2)
			i <- i+2
		}
		if (i <= (nrow(data)-1) & data[i,1] == data[i+1,1] & data[i,4] == 0 & data[i+1,4] == 1) {
			if (data[i+2,4] == 0) {
				aux1 <- c(data[i,1], 0, 1, data[i,5])
				aux2 <- c(data[i,1], data[i,3], 2, data[i,5])
				aux3 <- c(data[i,1], data[i+2,3], 2, data[i,5])
				data2 <- rbind(data2, aux1, aux2, aux3)
			}
			if (data[i+2,4] == 1) {
				aux1 <- c(data[i,1], 0, 1, data[i,5])
				aux2 <- c(data[i,1], data[i,3], 2, data[i,5])
				aux3 <- c(data[i,1], data[i+2,3], 3, data[i,5])
				data2 <- rbind(data2, aux1, aux2, aux3)
			}
			i <- i+3
		}
	}
	data2 <- data.frame(data2, row.names=NULL)
	names(data2) <- c("PTNUM", "time", "state", "covariate")
	data2 <- data2[-1,]
	class(data2) <- c(class(data2), "THMM")
	return(data2)
}

toTHMM.TDCM <- function(coxdata) {
	if ( !inherits(coxdata, "TDCM") ) stop("'coxdata' must be of class 'TDCM'", call.=FALSE)
	dados <- cbind(coxdata$start, coxdata$stop, coxdata$event, coxdata$covariate, coxdata$tdcov)
	dados <- data.frame(dados, row.names=NULL)
	names(dados) <- c("start", "stop", "event", "covariate", "tdcov")
	data <- dados
	data2 <- data.frame()
	j <- 1
	i <- 1
	doente <- 1
	ultimo <- 0
	while ( i <= nrow(data) ) {
		if ( i == nrow(data) ) ultimo <- 1
		if (ultimo == 0 & data[i,2] == data[i+1,1] & data[i+1,3] == 0) {
			data2[j,1] <- doente
			data2[j,2] <- 0
			data2[j,3] <- 1
			data2[j,4] <- data[i,4]
			j <- j+1
			data2[j,1] <- doente
			data2[j,2] <- data[i,2]
			data2[j,3] <- 2
			data2[j,4] <- data[i,4]
			j <- j+1
			data2[j,1] <- doente
			data2[j,2] <- data[i+1,2]
			data2[j,3] <- 2
			data2[j,4] <- data[i,4]
			i <- i+2
			j <- j+1
			doente <- doente+1
		} else {
			if (ultimo == 0 & data[i,2] == data[i+1,1] & data[i+1,3] == 1) {
				data2[j,1] <- doente
				data2[j,2] <- 0
				data2[j,3] <- 1
				data2[j,4] <- data[i,4]
				j <- j+1
				data2[j,1] <- doente
				data2[j,2] <- data[i,2]
				data2[j,3] <- 2
				data2[j,4] <- data[i,4]
				j <- j+1
				data2[j,1] <- doente
				data2[j,2] <- data[i+1,2]
				data2[j,3] <- 3
				data2[j,4] <- data[i,4]
				i <- i+2
				j <- j+1
				doente <- doente+1
			} else {
				if (data[i,3] == 1) {
					data2[j,1] <- doente
					data2[j,2] <- 0
					data2[j,3] <- 1
					data2[j,4] <- data[i,4]
					j <- j+1
					data2[j,1] <- doente
					data2[j,2] <- data[i,2]
					data2[j,3] <- 3
					data2[j,4] <- data[i,4]
					i <- i+1
					j <- j+1
					doente <- doente+1
				} else {
					data2[j,1] <- doente
					data2[j,2] <- 0
					data2[j,3] <- 1
					data2[j,4] <- data[i,4]
					j <- j+1
					data2[j,1] <- doente
					data2[j,2] <- data[i,2]
					data2[j,3] <- 1
					data2[j,4] <- data[i,4]
					i <- i+1
					j <- j+1
					doente <- doente+1
				}
			}
		}
	}
	names(data2) <- c("PTNUM", "time", "state", "covariate")
	class(data2) <- c(class(data2), "THMM")
	return(data2)
}
